window.Gleam.initSearch([{"doc":"kreator","title":"kreator","content":"# kreator\n\n[![Package Version](https://img.shields.io/hexpm/v/kreator)](https://hex.pm/packages/kreator)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-ffaff3)](https://hexdocs.pm/kreator/)\n\n```sh\ngleam add kreator\n```\n\nThis is a very wip query builder made in pure gleam to be used with multiple DB dialects.\n\n```gleam\nimport kreator as k\nimport sqlight\n\npub fn main() {\n    use conn &lt;- sqlight.with_connection(&quot;:memory:&quot;)\n    let query = k.table(&quot;articles&quot;) |&gt; k.to_sqlite()\n    sqlight.query(\n        query.sql,\n        on: conn,\n        with: [],\n        expecting: decoder(),\n    )\n}\n```\n\nFurther documentation can be found at &lt;https://hexdocs.pm/kreator&gt;.\n\n## Development\n\n```sh\ngleam run   # Run the project\ngleam test  # Run the tests\ngleam shell # Run an Erlang shell\n```\n\n#### TODO\n- [ ] add codec support generated from schema files\n- [ ] add joins\n- [ ] add aggregations\n- [ ] add subqueries\n- [ ] add pagination helpers\n","url":"index.html"},{"doc":"kreator/utils/string","title":"parenthesify","content":"pub fn parenthesify(string: StringBuilder) -&gt; StringBuilder\n\nSynonyms:\nkreator/utils/string.parenthesify\nkreator/utils/string parenthesify","url":"kreator/utils/string.html#parenthesify"},{"doc":"kreator/utils/string","title":"wrap_string","content":"pub fn wrap_string(\n  string: String,\n  wrapper: String,\n) -&gt; StringBuilder\n\nSynonyms:\nkreator/utils/string.wrap_string\nkreator/utils/string wrap_string","url":"kreator/utils/string.html#wrap_string"},{"doc":"kreator/utils/string","title":"wrap_string_builder","content":"pub fn wrap_string_builder(\n  string: StringBuilder,\n  wrapper: String,\n) -&gt; StringBuilder\n\nSynonyms:\nkreator/utils/string.wrap_string_builder\nkreator/utils/string wrap_string_builder","url":"kreator/utils/string.html#wrap_string_builder"},{"doc":"kreator/utils/string","title":"kreator/utils/string","content":"","url":"kreator/utils/string.html"},{"doc":"kreator/dialect","title":"Dialect","content":"pub type Dialect {\n  SQLite\n  Postgres\n  MySQL\n}\n\nSQLite\n\n\nPostgres\n\n\nMySQL\n\n\nSynonyms:\nkreator/dialect.Dialect\nkreator/dialect Dialect","url":"kreator/dialect.html#Dialect"},{"doc":"kreator/dialect","title":"string_quote","content":"pub fn string_quote(dialect: Dialect) -&gt; String\n\nSynonyms:\nkreator/dialect.string_quote\nkreator/dialect string_quote","url":"kreator/dialect.html#string_quote"},{"doc":"kreator/dialect","title":"symbol_quote","content":"pub fn symbol_quote(dialect: Dialect) -&gt; String\n\nSynonyms:\nkreator/dialect.symbol_quote\nkreator/dialect symbol_quote","url":"kreator/dialect.html#symbol_quote"},{"doc":"kreator/dialect","title":"wrap_column","content":"pub fn wrap_column(\n  column: String,\n  dialect: Dialect,\n) -&gt; StringBuilder\n\nSynonyms:\nkreator/dialect.wrap_column\nkreator/dialect wrap_column","url":"kreator/dialect.html#wrap_column"},{"doc":"kreator/dialect","title":"kreator/dialect","content":"","url":"kreator/dialect.html"},{"doc":"kreator/order","title":"Direction","content":"pub type Direction {\n  Ascending\n  Descending\n}\n\nAscending\n\n\nDescending\n\n\nSynonyms:\nkreator/order.Direction\nkreator/order Direction","url":"kreator/order.html#Direction"},{"doc":"kreator/order","title":"Order","content":"pub type Order =\n  #(String, Direction)\n\n\nSynonyms:\nkreator/order.Order\nkreator/order Order","url":"kreator/order.html#Order"},{"doc":"kreator/order","title":"to_string","content":"pub fn to_string(\n  order: #(String, Direction),\n  dialect: Dialect,\n) -&gt; StringBuilder\n\nSynonyms:\nkreator/order.to_string\nkreator/order to_string","url":"kreator/order.html#to_string"},{"doc":"kreator/order","title":"type_to_string","content":"pub fn type_to_string(direction: Direction) -&gt; String\n\nSynonyms:\nkreator/order.type_to_string\nkreator/order type_to_string","url":"kreator/order.html#type_to_string"},{"doc":"kreator/order","title":"kreator/order","content":"","url":"kreator/order.html"},{"doc":"kreator/value","title":"Value","content":"pub type Value {\n  String(String)\n  Int(Int)\n  Float(Float)\n  Bool(Bool)\n  Raw(String)\n}\n\nString(String)\n\n\nInt(Int)\n\n\nFloat(Float)\n\n\nBool(Bool)\n\n\nRaw(String)\n\n\nSynonyms:\nkreator/value.Value\nkreator/value Value","url":"kreator/value.html#Value"},{"doc":"kreator/value","title":"as_int","content":"pub fn as_int(i: Int) -&gt; Value\n\nSynonyms:\nkreator/value.as_int\nkreator/value as_int","url":"kreator/value.html#as_int"},{"doc":"kreator/value","title":"as_string","content":"pub fn as_string(i: String) -&gt; Value\n\nSynonyms:\nkreator/value.as_string\nkreator/value as_string","url":"kreator/value.html#as_string"},{"doc":"kreator/value","title":"convert","content":"pub fn convert(value: Value, dialect: Dialect) -&gt; StringBuilder\n\nSynonyms:\nkreator/value.convert\nkreator/value convert","url":"kreator/value.html#convert"},{"doc":"kreator/value","title":"kreator/value","content":"","url":"kreator/value.html"},{"doc":"kreator/utils/list","title":"head","content":"pub fn head(list: List(a)) -&gt; List(a)\n\nSynonyms:\nkreator/utils/list.head\nkreator/utils/list head","url":"kreator/utils/list.html#head"},{"doc":"kreator/utils/list","title":"kreator/utils/list","content":"","url":"kreator/utils/list.html"},{"doc":"kreator/where","title":"Where","content":"pub type Where {\n  WhereBasic(\n    where_type: WhereType,\n    column: String,\n    operator: String,\n    value: Value,\n  )\n  WhereWrapped(where_type: WhereType, list: List(Where))\n}\n\nWhereBasic(\n  where_type: WhereType,\n  column: String,\n  operator: String,\n  value: Value,\n)\n\n\nWhereWrapped(where_type: WhereType, list: List(Where))\n\n\nSynonyms:\nkreator/where.Where\nkreator/where Where","url":"kreator/where.html#Where"},{"doc":"kreator/where","title":"WhereType","content":"pub type WhereType {\n  And\n  Or\n}\n\nAnd\n\n\nOr\n\n\nSynonyms:\nkreator/where.WhereType\nkreator/where WhereType","url":"kreator/where.html#WhereType"},{"doc":"kreator/where","title":"add","content":"pub fn add(\n  where_list: List(Where),\n  new_where: Where,\n) -&gt; List(Where)\n\nSynonyms:\nkreator/where.add\nkreator/where add","url":"kreator/where.html#add"},{"doc":"kreator/where","title":"and_where_equals","content":"pub fn and_where_equals(\n  where_list: List(Where),\n  column: String,\n  value: Value,\n) -&gt; List(Where)\n\nSynonyms:\nkreator/where.and_where_equals\nkreator/where and_where_equals","url":"kreator/where.html#and_where_equals"},{"doc":"kreator/where","title":"equals","content":"pub fn equals(\n  column column: String,\n  value value: Value,\n  where_type where_type: WhereType,\n) -&gt; Where\n\nSynonyms:\nkreator/where.equals\nkreator/where equals","url":"kreator/where.html#equals"},{"doc":"kreator/where","title":"flatten","content":"pub fn flatten(\n  where_list: List(Where),\n) -&gt; List(#(WhereType, String, String, Value))\n\nSynonyms:\nkreator/where.flatten\nkreator/where flatten","url":"kreator/where.html#flatten"},{"doc":"kreator/where","title":"new_where_list","content":"pub fn new_where_list() -&gt; List(Where)\n\nSynonyms:\nkreator/where.new_where_list\nkreator/where new_where_list","url":"kreator/where.html#new_where_list"},{"doc":"kreator/where","title":"or_where_equals","content":"pub fn or_where_equals(\n  where_list: List(Where),\n  column: String,\n  value: Value,\n) -&gt; List(Where)\n\nSynonyms:\nkreator/where.or_where_equals\nkreator/where or_where_equals","url":"kreator/where.html#or_where_equals"},{"doc":"kreator/where","title":"type_to_string","content":"pub fn type_to_string(\n  value: WhereType,\n  dialect: Dialect,\n) -&gt; StringBuilder\n\nSynonyms:\nkreator/where.type_to_string\nkreator/where type_to_string","url":"kreator/where.html#type_to_string"},{"doc":"kreator/where","title":"values","content":"pub fn values(where_list: List(Where)) -&gt; List(Value)\n\nSynonyms:\nkreator/where.values\nkreator/where values","url":"kreator/where.html#values"},{"doc":"kreator/where","title":"kreator/where","content":"","url":"kreator/where.html"},{"doc":"kreator/query","title":"Query","content":"pub type Query {\n  Query(sql: String, bindings: List(Value))\n}\n\nQuery(sql: String, bindings: List(Value))\n\n\nSynonyms:\nkreator/query.Query\nkreator/query Query","url":"kreator/query.html#Query"},{"doc":"kreator/query","title":"get_sql","content":"pub fn get_sql(query: Query) -&gt; String\n\nSynonyms:\nkreator/query.get_sql\nkreator/query get_sql","url":"kreator/query.html#get_sql"},{"doc":"kreator/query","title":"kreator/query","content":"","url":"kreator/query.html"},{"doc":"kreator","title":"Blueprint","content":"pub type Blueprint {\n  Blueprint(\n    method: Method,\n    table: String,\n    columns: List(String),\n    order_by: List(Order),\n    where_clauses: List(Where),\n    data: List(#(String, Value)),\n  )\n}\n\nBlueprint(\n  method: Method,\n  table: String,\n  columns: List(String),\n  order_by: List(Order),\n  where_clauses: List(Where),\n  data: List(#(String, Value)),\n)\n\n\nSynonyms:\nkreator.Blueprint\nkreator Blueprint","url":"kreator.html#Blueprint"},{"doc":"kreator","title":"Method","content":"pub type Method {\n  Select\n  Insert\n  Update\n  Delete\n}\n\nSelect\n\n\nInsert\n\n\nUpdate\n\n\nDelete\n\n\nSynonyms:\nkreator.Method\nkreator Method","url":"kreator.html#Method"},{"doc":"kreator","title":"and_where","content":"pub fn and_where(\n  blueprint: Blueprint,\n  fun: fn(List(Where)) -&gt; List(Where),\n) -&gt; Blueprint\n\nSynonyms:\nkreator.and_where\nkreator and_where","url":"kreator.html#and_where"},{"doc":"kreator","title":"delete","content":"pub fn delete(blueprint: Blueprint) -&gt; Blueprint\n\nSynonyms:\nkreator.delete\nkreator delete","url":"kreator.html#delete"},{"doc":"kreator","title":"delete_builder","content":"pub fn delete_builder(\n  blueprint: Blueprint,\n  dialect: Dialect,\n) -&gt; Query\n\nSynonyms:\nkreator.delete_builder\nkreator delete_builder","url":"kreator.html#delete_builder"},{"doc":"kreator","title":"insert","content":"pub fn insert(\n  blueprint: Blueprint,\n  data: List(#(String, Value)),\n) -&gt; Blueprint\n\nSynonyms:\nkreator.insert\nkreator insert","url":"kreator.html#insert"},{"doc":"kreator","title":"insert_builder","content":"pub fn insert_builder(\n  blueprint: Blueprint,\n  dialect: Dialect,\n) -&gt; Query\n\nSynonyms:\nkreator.insert_builder\nkreator insert_builder","url":"kreator.html#insert_builder"},{"doc":"kreator","title":"or_where","content":"pub fn or_where(\n  blueprint: Blueprint,\n  fun: fn(List(Where)) -&gt; List(Where),\n) -&gt; Blueprint\n\nSynonyms:\nkreator.or_where\nkreator or_where","url":"kreator.html#or_where"},{"doc":"kreator","title":"or_where_equals","content":"pub fn or_where_equals(\n  blueprint: Blueprint,\n  column: String,\n  value: Value,\n) -&gt; Blueprint\n\nSynonyms:\nkreator.or_where_equals\nkreator or_where_equals","url":"kreator.html#or_where_equals"},{"doc":"kreator","title":"order_by","content":"pub fn order_by(\n  blueprint: Blueprint,\n  column column: String,\n  direction direction: Direction,\n) -&gt; Blueprint\n\nSynonyms:\nkreator.order_by\nkreator order_by","url":"kreator.html#order_by"},{"doc":"kreator","title":"select","content":"pub fn select(\n  blueprint: Blueprint,\n  select: List(String),\n) -&gt; Blueprint\n\nSynonyms:\nkreator.select\nkreator select","url":"kreator.html#select"},{"doc":"kreator","title":"select_builder","content":"pub fn select_builder(\n  blueprint: Blueprint,\n  dialect: Dialect,\n) -&gt; Query\n\nSynonyms:\nkreator.select_builder\nkreator select_builder","url":"kreator.html#select_builder"},{"doc":"kreator","title":"table","content":"pub fn table(table: String) -&gt; Blueprint\n\nSynonyms:\nkreator.table\nkreator table","url":"kreator.html#table"},{"doc":"kreator","title":"to_postgres","content":"pub fn to_postgres(blueprint: Blueprint) -&gt; Query\n\nSynonyms:\nkreator.to_postgres\nkreator to_postgres","url":"kreator.html#to_postgres"},{"doc":"kreator","title":"to_query","content":"pub fn to_query(\n  from blueprint: Blueprint,\n  for dialect: Dialect,\n) -&gt; Query\n\nSynonyms:\nkreator.to_query\nkreator to_query","url":"kreator.html#to_query"},{"doc":"kreator","title":"to_sqlite","content":"pub fn to_sqlite(blueprint: Blueprint) -&gt; Query\n\nSynonyms:\nkreator.to_sqlite\nkreator to_sqlite","url":"kreator.html#to_sqlite"},{"doc":"kreator","title":"update","content":"pub fn update(\n  blueprint: Blueprint,\n  data: List(#(String, Value)),\n) -&gt; Blueprint\n\nSynonyms:\nkreator.update\nkreator update","url":"kreator.html#update"},{"doc":"kreator","title":"update_builder","content":"pub fn update_builder(\n  blueprint: Blueprint,\n  dialect: Dialect,\n) -&gt; Query\n\nSynonyms:\nkreator.update_builder\nkreator update_builder","url":"kreator.html#update_builder"},{"doc":"kreator","title":"where_equals","content":"pub fn where_equals(\n  blueprint: Blueprint,\n  column: String,\n  value: Value,\n) -&gt; Blueprint\n\nSynonyms:\nkreator.where_equals\nkreator where_equals","url":"kreator.html#where_equals"},{"doc":"kreator","title":"where_equals_string","content":"pub fn where_equals_string(\n  blueprint: Blueprint,\n  column: String,\n  value: String,\n) -&gt; Blueprint\n\nSynonyms:\nkreator.where_equals_string\nkreator where_equals_string","url":"kreator.html#where_equals_string"},{"doc":"kreator","title":"kreator","content":"","url":"kreator.html"}]);